# Project name:	Meltdown BBS Utilities
# File:		export-filelist.pl
# Version:	1.0 alpha
# Copyright:	(c) 2004 Petko Bossakov
# Email:	pbosakov@yahoo.com
# WWW:		http://meltdown-bbs.sourceforge.net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

use strict;
use DBI;
use Getopt::Std;
our $opt_a;
getopt('a');

my $dbhost = readini("SQL", "host");
my $dbname = readini("SQL", "dbname");
my $dbuser = readini("SQL", "username");
my $dbpass = readini("SQL", "password");
my ($db, $query, $query2, $query3, $row, $path, $areaid);

###############################
# Connect to the MySQL server #
###############################

$db = DBI->connect("dbi:mysql:database=$dbname;host=$dbhost", $dbuser, $dbpass,
                      { RaiseError => 1, AutoCommit => 1 });

print "\nMeltdown BBS Utilities filelist export script";
print "\nversion 1.0 alpha";
print "\n\n";
print "(usage: export-filelist.pl [-a file_area_number])";
print "\n\n";

if($opt_a > 0) {
	&export_area($opt_a);
}
else {
	$query3 = $db->prepare("SELECT areaid FROM areas");
	$query3->execute;
	while ($areaid=$query3->fetchrow_array) {
		&export_area($areaid);
	}
}

close INI;
$db->disconnect;

#########################
# export_area(areaid)   #
# exports a single area #
#########################

sub export_area {
	$query = $db->prepare("SELECT path FROM areas WHERE areaid=? LIMIT 1");
	$query->execute($_[0]);
	while ( $path = $query->fetchrow_array ) {
		open(FILESBBS, ">$path/files.bbs") || die "Can't write to files.bbs in $path: $!\n";
		$query2 = $db->prepare("SELECT filename, description FROM files WHERE areaid=? ORDER BY filename");
		$query2->execute($_[0]);
		my $filecount=0;
		while ( $row = $query2->fetchrow_hashref ) {
			my $file = ${$row}{'filename'};
			if($file =~ m/^[^"].* .*[^"]$/) { $file = "\"$file\""; }
			print FILESBBS "$file ${$row}{'description'}\n";
			$filecount++;
		}
		close FILESBBS;
		print "Exported $filecount files from area $_[0]\n";
	}
}

#################################
# readini (section, key, value) #
# reads data from an INI file   #
#################################

sub readini {
	my ($section, $key, $value);
	($section, $key) = @_;
	undef $/;

	open (INI, "mdutil.ini") || die "Can't open mdutil.ini: $!\n";
		while (<INI>) {
			if ( $_ =~ m/^\[$section\]\s*\n([^\n]*\n)*"?$key"?\s*=\s*"?([^\n]+)"?\s*(\n|$)/im ) {
				return $2;
			}
		}
	return "";
}
