# Project name:	Meltdown BBS Utilities
# File:		import-filelist.pl
# Version:	1.0 alpha
# Copyright:	(c) 2004 Petko Bossakov
# Email:	pbosakov@yahoo.com
# WWW:		http://meltdown-bbs.sourceforge.net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# Project name:	Meltdown BBS Utilities
# File:		export-filelist.pl
# Version:	1.0 alpha
# Copyright:	(c) 2004 Petko Bossakov
# Email:	pbosakov@yahoo.com
# WWW:		http://meltdown-bbs.sourceforge.net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

use strict;
use DBI;
use Getopt::Std;
use LWP::MediaTypes;
our $opt_a;
getopt('a');

my $dbhost = readini("SQL", "host");
my $dbname = readini("SQL", "dbname");
my $dbuser = readini("SQL", "username");
my $dbpass = readini("SQL", "password");
my ($db, $query, $query2, $query3, $row, $path, $areaid);

###############################
# Connect to the MySQL server #
###############################

$db = DBI->connect("dbi:mysql:database=$dbname;host=$dbhost", $dbuser, $dbpass,
                      { RaiseError => 1, AutoCommit => 1 });

print "\nMeltdown BBS Utilities filelist import script";
print "\nversion 1.0 alpha";
print "\n\n";
print "(usage: import-filelist.pl [-a file_area_number])";
print "\n\n";

if($opt_a > 0) {
	&import_area($opt_a);
}
else {
	$query3 = $db->prepare("SELECT areaid FROM areas");
	$query3->execute;
	while ($areaid=$query3->fetchrow_array) {
		&import_area($areaid);
	}
}

close INI;
$db->disconnect;

#########################
# import_area(areaid)   #
# imports a single area #
#########################

sub import_area {
	my $areaid = $_[0];

	$query = $db->prepare("SELECT path FROM areas WHERE areaid=? LIMIT 1");
	$query->execute($areaid);
	while ( $path = $query->fetchrow_array ) {
		open(FILESBBS, "<$path/files.bbs") || die "Can't read from files.bbs in $path: $!\n";
		$/ = "\n";
		while (<FILESBBS>) {
			my ($filename, $description);

			if ($_ =~ m/^ *"/) {
				$_ =~ m/^"(.*?)" (.*)$/;
				$filename = $1;
				$description = $2;
			} else {
				$_ =~ m/^(.*?) (.*)$/;
				$filename = $1;
				$description = $2;
			}

			opendir(DIR, $path) || die "Can't opendir $path: $!\n";
			my $file = grep { /^$filename/i } readdir(DIR);
			closedir DIR;
			if ($file) {
				# Check if file alerady exists in area
				$query2 = $db->prepare("SELECT COUNT(*) FROM files WHERE areaid=? and filename=?");
				$query2->execute($areaid, $filename);
				my $result = $query2->fetchrow_array;
				if ($result == 0) {
					my $mime = guess_media_type("$path/$filename");
					$query2 = $db->prepare("INSERT INTO files(filename, areaid, description, upload_time, mime_type) VALUES(?,?,?,UNIX_TIMESTAMP(),?)");
					$query2->execute($filename, $areaid, $description, $mime);
					print "Imported file $filename into area $areaid.\n";
				}
				undef $query2;
			}
		}
	}
	close FILESBBS;
}

#################################
# readini (section, key, value) #
# reads data from an INI file   #
#################################

sub readini {
	my ($section, $key, $value);
	($section, $key) = @_;
	undef $/;

	open (INI, "mdutil.ini") || die "Can't open mdutil.ini: $!\n";
		while (<INI>) {
			if ( $_ =~ m/^\[$section\]\s*\n([^\n]*\n)*"?$key"?\s*=\s*"?([^\n]+)"?\s*(\n|$)/im ) {
				return $2;
			}
		}
	return "";
}
