# Project name:	Meltdown BBS Utilities
# File:		list-areas.pl
# Version:	1.0 alpha
# Copyright:	(c) 2004 Petko Bossakov
# Email:	pbosakov@yahoo.com
# WWW:		http://meltdown-bbs.sourceforge.net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

use strict;
use DBI;

my $dbhost = readini("SQL", "host");
my $dbname = readini("SQL", "dbname");
my $dbuser = readini("SQL", "username");
my $dbpass = readini("SQL", "password");
my ($db, $query, $row);

###############################
# Connect to the MySQL server #
###############################

$db = DBI->connect("dbi:mysql:database=$dbname;host=$dbhost", $dbuser, $dbpass,
                      { RaiseError => 1, AutoCommit => 1 });

######################
# Now fetch the list #
######################

$query = $db->prepare("SELECT echoid, name, description FROM echos ORDER BY order_num");
$query->execute;

print "Message areas:\n";
print "==============\n";
print "ID\tName\tDescription\n";
print "-" x 80;
while ( $row = $query->fetchrow_hashref ) {
	print "\n${$row}{'echoid'}\t${$row}{'name'}\t${$row}{'description'}";
}

$query = $db->prepare("SELECT areaid, name, description FROM areas ORDER BY order_num");
$query->execute;

print "\n\nFile areas:\n";
print "===========\n";
print "ID\tName\tDescription\n";
print "-" x 80;
while ( $row = $query->fetchrow_hashref ) {
	print "\n${$row}{'areaid'}\t${$row}{'name'}\t${$row}{'description'}";
}

close INI;
$db->disconnect;

#################################
# readini (section, key, value) #
# reads data from an INI file   #
#################################

sub readini {
	my ($section, $key, $value);
	($section, $key) = @_;
	undef $/;

	open (INI, "mdutil.ini") || die "Can't open mdutil.ini: $!\n";
		while (<INI>) {
			if ( $_ =~ m/^\[$section\]\s*\n([^\n]*\n)*"?$key"?\s*=\s*"?([^\n]+)"?\s*(\n|$)/im ) {
				return $2;
			}
		}
	return "";
}
