# Project name:	Meltdown BBS Utilities
# File:		list-areas.pl
# Version:	1.0 alpha
# Copyright:	(c) 2004 Petko Bossakov
# Email:	pbosakov@yahoo.com
# WWW:		http://meltdown-bbs.sourceforge.net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

use strict;
use DBI;

my $dbhost = readini("SQL", "host");
my $dbname = readini("SQL", "dbname");
my $dbuser = readini("SQL", "username");
my $dbpass = readini("SQL", "password");
my ($db, $query, $row);

###############################
# Connect to the MySQL server #
###############################

$db = DBI->connect("dbi:mysql:database=$dbname;host=$dbhost", $dbuser, $dbpass,
                      { RaiseError => 1, AutoCommit => 1 });

$query = $db->prepare("SELECT * FROM users");
$query->execute;

while ( $row = $query->fetchrow_hashref ) {
	print "\nUser ID:\t${$row}{'userid'}";
	print "\nName:\t\t${$row}{'firstname'} ${$row}{'lastname'}";
	print "\nAccess level:\t${$row}{'level'}";
	print "\nEmail:\t\t${$row}{'email'}";
	print "\nUploads:\t${$row}{'uploads'}";
	print "\nDownloads:\t${$row}{'downloads'}";
	print "\nRegistered on:\t" . localtime(${$row}{'regdate'});
	print "\nLast online:\t" . localtime(${$row}{'lastvisit'});
	print "\nLanguage:\t${$row}{'language'}";
	print "\nTemplate:\t${$row}{'template'}";
	print "\n" . '-' x 40;
}

close INI;
$db->disconnect;

#################################
# readini (section, key, value) #
# reads data from an INI file   #
#################################

sub readini {
	my ($section, $key, $value);
	($section, $key) = @_;
	undef $/;

	open (INI, "mdutil.ini") || die "Can't open mdutil.ini: $!\n";
		while (<INI>) {
			if ( $_ =~ m/^\[$section\]\s*\n([^\n]*\n)*"?$key"?\s*=\s*"?([^\n]+)"?\s*(\n|$)/im ) {
				return $2;
			}
		}
	return "";
}
